diff a/src/hotspot/share/ci/ciFlatArray.hpp b/src/hotspot/share/ci/ciFlatArray.hpp
--- /dev/null
+++ b/src/hotspot/share/ci/ciFlatArray.hpp
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 2017, 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#ifndef SHARE_VM_CI_CIFLATARRAY_HPP
+#define SHARE_VM_CI_CIFLATARRAY_HPP
+
+#include "ci/ciArray.hpp"
+#include "ci/ciClassList.hpp"
+#include "oops/flatArrayOop.hpp"
+
+// ciFlatArray
+//
+// This class represents a flatArrayOop in the HotSpot virtual machine.
+class ciFlatArray : public ciArray {
+  CI_PACKAGE_ACCESS
+
+protected:
+  ciFlatArray(flatArrayHandle h_o) : ciArray(h_o) {}
+
+  const char* type_string() { return "ciFlatArray"; }
+
+public:
+  bool is_flat()      { return true; }
+  bool is_null_free() { return true; }
+};
+
+#endif // SHARE_VM_CI_CIFLATARRAY_HPP
